#ifndef BIT_FIELD_HEADER_INCLUDED
#define BIT_FIELD_HEADER_INCLUDED

/* ------ Bit field header ------ */
/* A set of bitfield operations */

#include "ghead.h"

typedef guint16 BITFIELD;
#define BITS_ON_FIELD 16

/* ------ Globals ------ */
gsize maxFieldSize;
#define GETBITFIELDSIZE maxFieldSize

void StartBitFields (SCOUNTER bits);
void EndBitFields ();

BITFIELD* CreateBitField ();
void ResetBitField (BITFIELD* a);

void PutBitOn (BITFIELD* a, SCOUNTER bit);
SFLAG IsBitOn (BITFIELD* a, SCOUNTER bit);
void CopyBitField (BITFIELD* dest, BITFIELD* src);

SFLAG BitFieldAnd (BITFIELD* a1, BITFIELD* a2);

void BitFieldORsum (BITFIELD* dest, BITFIELD* src);
void BitFieldANDsum (BITFIELD* dest, BITFIELD* src);
void BitFieldRemove (BITFIELD* dest, BITFIELD* toRemov);

void BitFieldAddNotRemoved (BITFIELD* dest, BITFIELD* src, BITFIELD* toRemov);

SCOUNTER CountBits (BITFIELD* a);
SCOUNTER BitFieldCommon (BITFIELD* a, BITFIELD* b);

#endif
