#ifndef GRID_HEADER_INCLUDED
#define GRID_HEADER_INCLUDED

#include "ghead.h"
#include "bitfield.h"
#include "biogeo.h"

typedef struct tagQUADTREE QUADTREE;
struct tagQUADTREE {
 SINTEGER firstRow;
 SINTEGER lastRow;
 SINTEGER firstCol;
 SINTEGER lastCol;
 SCOUNTER cell;
 SINTEGER size;
 SFLAG state;
 SFLAG obsCell;
 GNode* node;
};

/* ------ Global variables ------ */
SCOUNTER numCells;
SCOUNTER numRows;
SCOUNTER numCols;

#define GETNUMCELLS numCells
#define GETNUMCOLS  numCols
#define GETNUMROWS  numRows

SREAL actualGridSize;
SREAL gridStartX;
SREAL gridStartY;
SCOUNTER actualFill;

#define GETGRIDSIZE   actualGridSize
#define GETGRIDSTARTX gridStartX
#define GETGRIDSTARTY gridStartY
#define GETFILL       actualFill

#define SETGRIDSIZE(x)   actualGridSize = (x)
#define SETFILL(x)       actualFill = (x)

/* ------ Functions ------ */
SCOUNTER GetCell (SINTEGER row, SINTEGER col);
void CreateGrid ();
void DestroyGrid ();

SFLAG GetGridState ();

void MapIntoQTree (BITFIELD* setA, BITFIELD* setB);
SFLAG GetRowColState (SINTEGER row, SINTEGER col);
void GetColRowFromCell (SCOUNTER cell, SINTEGER* row, SINTEGER* col);

SCOUNTER GetCellIfObs (SINTEGER row, SINTEGER col);

void FillWithReference (TERMINAL* term, BITFIELD* ref, BITFIELD* dest, SFLAG mode);
void GetObsSet (BITFIELD* obs, GNode* refNode);

#endif
