#ifndef VORONOI_HEADER_INCLUDED
#define VORONOI_HEADER_INCLUDED

/* ------ Data types for the Voronoi "line" used to mark disjunctions ------ */

#include "biogeo.h"
#include "grid.h"
#include "bitfield.h"

#define STATE_NOCELL 0
#define STATE_SETA   1
#define STATE_SETB   2

typedef struct tagBEACHARC BEACHARC;
struct tagBEACHARC {
 SCOUNTER baseCell;
 SREAL baseRow;
 SREAL baseCol;
 SREAL baseState;
 GList* event;
 SREAL lastCol;
 SREAL lastLeft;
 SREAL lastRight;
 SFLAG toDel;
};

typedef struct tagDELAUNAYTRIANGLE DELAUNAYTRIANGLE;
struct tagDELAUNAYTRIANGLE {
 SCOUNTER cellA;
 SCOUNTER cellB;
 SCOUNTER cellC;
 SFLAG stateA;
 SFLAG stateB;
 SFLAG stateC;
 SREAL cX;
 SREAL cY;
 SCOUNTER abNeighbor;
 SCOUNTER acNeighbor;
 SCOUNTER bcNeighbor;
};

typedef struct tagCIRCEVENT CIRCEVENT;
struct tagCIRCEVENT {
 GList* pArc;
 SREAL circleCol;
 SREAL cX;
 SREAL cY;
};

GPtrArray* MakeVoronoi (BITFIELD* iniA, BITFIELD* iniB);
void DestroyTriangleList (GPtrArray* triangleList);

#endif
